#
# init-db.sql: sql to set up tables for virtual email
#
# $Id: init-db.sql,v 1.5 2001/09/23 21:38:12 pdw Exp $
#

# this is the table which holds information about this domain
create table domain (
        domain_name varchar(255) primary key,   # domain name
        unix_user varchar(255),                 # which Unix user owns files etc.
        password_hash varchar(255),             # admin password for this domain
        path varchar(255),                      # base path for this domain
        max_popbox int                          # maximum number of popboxes in this domain
) ;

# forwarders, local and remote
create table forwarder (
        domain_name varchar(255) not null,      # domain this refers to
        local_part varchar(255) not null,       # local part we forward for
        remote_name varchar(255) not null,      # whom we forward to
        primary key (domain_name(16), local_part(32))
) ;

# local POP boxes (virtual)
create table popbox (
        domain_name varchar(255) not null,      # domain this refers to
        local_part varchar(255) not null,       # username for this POP box
        password_hash varchar(255),             # hash of this user's password
        mbox_name varchar(255),                 # appended to domain.path
        primary key (domain_name(16), local_part(32))
) ;

# domain aliases
CREATE TABLE domain_alias (
  domain_name varchar(255) DEFAULT '' NOT NULL, # domain to redirect to
  alias varchar(255) DEFAULT '' NOT NULL,       # alias for 'real' domain
  PRIMARY KEY (alias)
);
