#!/usr/bin/perl -w -I
#
# DomainAdminDB.pm:
#
# Copyright (c) 2001 Paul Warren. All rights reserved.
#
# $Id: DomainAdminDB.pm,v 1.2 2001/07/23 22:08:15 pdw Exp $
#
# $Log: DomainAdminDB.pm,v $
# Revision 1.2  2001/07/23 22:08:15  pdw
# Lots of changes including:
# scripts/* now use PasswordCrypt
# Added default_hash_method and allow_plaintext options.
# Makefile should now make dist properly.
#
# Revision 1.1  2001/07/17 22:12:57  pdw
# Refactoring DB code.  Non-working state.
#
#

package DomainAdminDB;

require DomainAdminConfig;


#
# new: 
#
sub new {
    my $class = shift;
    my $self = {
        dbh => undef,
        error => undef     
    };
    bless $self, $class;
    return $self;    
}

#
# connect:
#
sub connect {
    my $self = shift; 

    # If we're already connected, return gracefully (for compatiblity with existing code)
    if ($self->{dbh}) {
        return 1;
    }

    # TODO: The entire DSN should probably be a config option
    my $dsn = "DBI:mysql:database=$DomainAdminConfig::sqldb;host=localhost";
    $self->{dbh} = DBI->connect($dsn, $DomainAdminConfig::sqluser, $DomainAdminConfig::sqlpasswd, { RaiseError => 0 });
    if (!defined($self->{dbh})) {
        $self->error("Couldn't open database: $DBI::errstr");
        return undef;
    }
    return 1;
}

#
# retrieve_session( session_id )
#
sub retrieve_session {
    my $self = shift;
    my $id = shift;

    my $stmt = "SELECT domain_name, session_id, expires FROM web_session WHERE session_id = ?";
    my $sth = $self->{dbh}->prepare($stmt);
    if (!defined($sth)) {
        $self->error("Error preparing statement: $DBI::errstr");
        return undef;
    }
    my $ret = $sth->execute($id);
    if (!defined($ret)) {
        $self->error("Error executing statement: $DBI::errstr");
        return undef;
    }
    my $ar = $sth->fetchrow_arrayref();
    if(!$ar) {
        # Could not find session 
        return[undef, undef, undef];
    }
    if($sth->fetchrow_array()) {
        $self->error("More than one session with id '$id'");
        return undef;
    }
    return $ar; 
}

#
# dbh: returns the database handle.  This is a hack - really everything should
# be done through this class, but I don't have time to fully refactor...
#
sub dbh {
    my $self = shift;
    return $self->{dbh};
}


#
# error:
#
sub error {
    my $self = shift;
    my $e = shift;
    if (defined($e)) {
        $self->{error} = $e; 
    }
    return $self->{error};
}



1;
